/*
	Regulation + modele

	Grande Machine
	Lotfi BAGHLI			  17/07/1996	rev 03/09/1996
	Light pour moins de temps de calcul mais tjrs stator direct rev 17/04/1998
	Pour DS1104
	Lotfi BAGHLI			  rev 03/03/2003
*/

inline double sign(double x)
{
	if (x==0)	return 0;
	if (x>0)	return 1;
		else		return -1;
}

/* calcul de thetas, Wsl, Ws et du flux  */
#define Calc_thetas \
{ \
	Wsl= Iqsref / Tr / Idsref; \
	Phidr+=DT*( M*Ids-Phidr)/ Tr; \
	if (VectorControlFlag==1)		Ws=P*Wm+Wsl; \
	if (VectorControlFlag!=1)		Ws=Wsref; \
	if (VectorControlFlag==3)		{ Ws=0; th=0; }\
	th+=DT*Ws;		/* 200 us */ \
	if ( th > PI)		th-=TWOPI; \
	if ( th < -PI)		th+=TWOPI; \
}

void BoucleId()
{
	e=Idsref-Ids;
	Vdsref = Kpd*e + xed;
	if ( fabs(Vdsref)<=VdsrefMax )	xed += Kid*e;

	/* decouplage */
//	non valable en MASDE  Vdsref-=sigma*Ls*Ws*Iqs;

	/* limiteur de tension */
	if ( Vdsref>VdsrefMax) Vdsref=VdsrefMax;
	if ( Vdsref<-VdsrefMax) Vdsref=-VdsrefMax;
}

void BoucleIq()
{
	e=Iqsref-Iqs;
	Vqsref = Kpq*e + xeq;
	if ( fabs(Vqsref)<=VqsrefMax )	xeq += Kiq*e;

	/* decouplage */
//	non valable en MASDE  Vqsref+=sigma*Ls*Ws*Ids+M/Lr*Ws*Phidr;

	/* limiteur de tension */
	if ( Vqsref>VqsrefMax) Vqsref=VqsrefMax;
	if ( Vqsref<-VqsrefMax) Vqsref=-VqsrefMax;
}

/* attention regul sur la vitesse Wm ! */
void BoucleVitesse()
{
  /* La vitesse a ete calcule juste avant ds une macro */
	/* regul IP anti Windup */
	xeW += KiW / KpW*( Wmref - Wm - KTiW*(OldSortie - OldSortieSat) );
	/* limite le non sature pour eviter tt pb de debordement !!! */
	if ( xeW>xeWMax)	xeW=xeWMax;
	if ( xeW<-xeWMax)	xeW=-xeWMax;
	OldSortie = KpW*( xeW -Wm);

	OldSortieSat=OldSortie;			/* limiteur de courant */
	if ( OldSortieSat>IqsrefMax)	OldSortieSat=IqsrefMax;
	if ( OldSortieSat<-IqsrefMax)	OldSortieSat=-IqsrefMax;
	Iqsref=OldSortieSat;
	
	/* regul IP classique */
/*
	Iqsref=KpW*(xeW-Wm);
	if ( fabs(Iqsref)<=IqsrefMax )	xeW+=KiW/KpW*(Wmref-Wm);
	if ( Iqsref>IqsrefMax)	Iqsref=IqsrefMax;
	if ( Iqsref<-IqsrefMax)	Iqsref=-IqsrefMax;
*/
}

inline double  min(double value1, double value2)
	{
		return ( (value1 < value2) ? value1 : value2);
	}

inline double  max(double value1, double value2)
	{
		return ( (value1 > value2) ? value1 : value2);
	}

void Fuzzification( double Err, double *Err_hN, double *Err_hZ, double *Err_hP)
{
	if (Err<=-1.0)	{ *Err_hN=1; *Err_hZ=0; *Err_hP=0; return; }
	if (Err>=1.0)	{ *Err_hN=0; *Err_hZ=0; *Err_hP=1; return; }
	if (Err<=0)		{  *Err_hZ=1+Err;
							*Err_hN=-Err;
							*Err_hP=0;
							return; }
	if (Err>0)		{  *Err_hN=0;
							*Err_hZ=1-Err;
							*Err_hP=Err;
							return; }
}

#define Inference( Err_hN, Err_hZ, Err_hP, dErr_hN, dErr_hZ, dErr_hP, \
						 dU_hN, dU_hZ, dU_hP) \
{ \
	double h; \
	dU_hN=min( dErr_hN, Err_hN); \
	h=min( dErr_hN, Err_hZ);		if ( h>dU_hN )	dU_hN=h; \
	dU_hZ=min( dErr_hN, Err_hP); \
 \
	h=min( dErr_hZ, Err_hN);		if ( h>dU_hN )	dU_hN=h; \
	h=min( dErr_hZ, Err_hZ);		if ( h>dU_hZ )	dU_hZ=h; \
	dU_hP=min( dErr_hZ, Err_hP); \
 \
	h=min( dErr_hP, Err_hN);		if ( h>dU_hZ )	dU_hZ=h; \
	h=min( dErr_hP, Err_hZ);		if ( h>dU_hP )	dU_hP=h; \
	h=min( dErr_hP, Err_hP);		if ( h>dU_hP )	dU_hP=h; \
}
                     
#define Defuzzification( dU_hN, dU_hZ, dU_hP, dU)\
{ \
	if (dU_hN+dU_hZ+dU_hP==0)	dU=0; \
		else	dU=(dU_hP-dU_hN)/(dU_hN+dU_hZ+dU_hP); \
}

void BoucleFloueId()
{
	IdsErr=Idsref-Ids;
	IdsdErr=IdsErr-IdsOldE;
	IdsOldE=IdsErr;
	/* MoteurFlou, Fuzzification implicite */
	Fuzzification( IdsFErr*IdsErr, & IdsErr_hN, & IdsErr_hZ, & IdsErr_hP);
	Fuzzification( IdsFdErr*IdsdErr, & IdsdErr_hN, & IdsdErr_hZ, & IdsdErr_hP);
	/* Inference */
	Inference( IdsErr_hN, IdsErr_hZ, IdsErr_hP, IdsdErr_hN, IdsdErr_hZ, IdsdErr_hP,
						 IdsdU_hN, IdsdU_hZ, IdsdU_hP);   /* MIN MAX */
	Defuzzification( IdsdU_hN, IdsdU_hZ, IdsdU_hP, IdsdU);

	Vdsref+=IdsFdU*IdsdU;
	/* Pas de decouplage pour le flou */
	/* limiteur de tension */
	if ( Vdsref>VdsrefMax) Vdsref=VdsrefMax;
	if ( Vdsref<-VdsrefMax) Vdsref=-VdsrefMax;
}

void BoucleFloueIq()
{
	IqsErr=Iqsref-Iqs;
	IqsdErr=IqsErr-IqsOldE;
	IqsOldE=IqsErr;
	/* MoteurFlou, Fuzzification implicite */
	Fuzzification( IqsFErr*IqsErr, & IqsErr_hN, & IqsErr_hZ, & IqsErr_hP);
	Fuzzification( IqsFdErr*IqsdErr, & IqsdErr_hN, & IqsdErr_hZ, & IqsdErr_hP);
	/* Inference */
	Inference( IqsErr_hN, IqsErr_hZ, IqsErr_hP, IqsdErr_hN, IqsdErr_hZ, IqsdErr_hP,
						 IqsdU_hN, IqsdU_hZ, IqsdU_hP);   /* MIN MAX */
	Defuzzification( IqsdU_hN, IqsdU_hZ, IqsdU_hP, IqsdU);

	Vqsref+=IqsFdU*IqsdU;
	/* Pas de decouplage pour le flou */
	/* limiteur de tension */
	if ( Vqsref>VqsrefMax) Vqsref=VqsrefMax;
	if ( Vqsref<-VqsrefMax) Vqsref=-VqsrefMax;
}

/* attention regul sur la vitesse Wm ! */
void BoucleVitesseFloue()
{
  /* La vitesse a ete calcule juste avant ds une macro */
	WErr= Wmref-Wm;
	WdErr=WErr-OldWE;
	OldWE=WErr;
	/* MoteurFlou, Fuzzification implicite */
	Fuzzification( WFErr*WErr, & WErr_hN, & WErr_hZ, & WErr_hP);
	Fuzzification( WFdErr*WdErr, & WdErr_hN, & WdErr_hZ, & WdErr_hP);
	/* Inference */
	Inference( WErr_hN, WErr_hZ, WErr_hP, WdErr_hN, WdErr_hZ, WdErr_hP,
						 WdU_hN, WdU_hZ, WdU_hP);   /* MIN MAX */
	Defuzzification( WdU_hN, WdU_hZ, WdU_hP, WdU);
	Iqsref+=WFdU*WdU;
	/* check limits yohoho ! */
	if ( Iqsref>IqsrefMax)		Iqsref=IqsrefMax;
	if ( Iqsref<-IqsrefMax)		Iqsref=-IqsrefMax;
}

void BouclePosition()
{	/* regul P classique */
	Wmref= KpP * ( mposref-mpos);
	/* limiteur de vitesse */
	if ( Wmref>WmrefMax)		Wmref=WmrefMax;
	if ( Wmref<-WmrefMax)		Wmref=-WmrefMax;
}

/*******************************************************************************/
/* nouvelles routines spciales dues  la refonte du programme pour DS1104 */

void RegulI_Control()
{
/* get courants  et fems */
/* inputs via DS1104 on-board 12 bits Non-Muxed ADC channel 2, 3, 4 et 5 */

// pour la double toile ATTENTION : PAS d'OFFSETs
	inputI_doubleEtoile( Ias, Ibs, dIas, dIbs);
	Ics=-Ias-Ibs;
	dIcs=-dIas-dIbs;

  Ialphas=(Ias-(Ibs+Ics-r3*(dIas-dIbs))/2)/r3;
  Ibetas=-(dIcs-(dIbs+dIas-r3*(Ics-Ibs))/2)/r3;

	CalcPark( th, s, c);
	ParkInv( Ialphas, Ibetas, s, c, Ids, Iqs);

/*	ds1104_dac_write( 2, 0.5);	 signal out */
	Calc_thetas;	 	/*	update thetas and Phidr*/
/*	ds1104_dac_write( 2, 0.4);	 signal out */

	Wm=WmMesure;
	
	/*	ds1104_dac_write( 2, 0.3);		 signal out */
	/* Defluxage s'il y a lieu */
	absWm=fabs(Wm);

	/* if (Rotor_Stator==1) seulement si flux rotorique */
	switch ( Deflux_Type )
		{
		case 1 :	/* Deflux palier */
					if ( absWm<=Wmlim1b )							  				Idsref=Idsref1;
					if ( absWm >= Wmlim1 && absWm <= Wmlim2b )	Idsref=Idsref2;
					if ( absWm >= Wmlim2 )											Idsref=Idsref3;
					break;
		case 2 :	/* Deflux continu */
					if ( absWm<=WmBaseB )	Idsref=IdsrefBase;
					if ( absWm>WmBase )		Idsref=Kdeflux/absWm;
					break;
		}

	if ( CurrentControllerType )	{	/* Controlleur Flou 		*/
									BoucleFloueId();			 /*regul FLOUE de Ids */
									BoucleFloueIq();			 /*regul FLOUE de Iqs */
									}
				else		 	{	/* controlleurs classiques */
									BoucleId();
									VqsrefMax=sqrt(E_2*E_2-Vdsref*Vdsref);
									BoucleIq();
									}
// type de Cmde vect ou V/f (independante ou lie)
	switch ( VectorControlFlag )
		{
		case 0 :	//	V_f	independants
							Vdsref=Vsref;
							Vqsref=0.0;
					break;
		case 2 :	//	V/f	lis par K_V_f
							Vsref=K_V_f*fs;
							Wsref=2*PI*fs;
							Vdsref=Vsref;
							Vqsref=0.0;
							/* limiteur de tension */
							if ( Vdsref>270.0)	Vdsref=270.0;
							if ( Vdsref<-270.0) Vdsref=-270.0;
					break;
		default : //	case 1 ou autre : Vector control 
					break;
		}

	Park( Vdsref, Vqsref, s, c, Valphas, Vbetas);
//	C32( Valphas, Vbetas, Vas, Vbs, Vcs );
//modif DE
  Vas= (Valphas+Vxs+Vo1s)/r3;
  Vbs=-(Valphas+Vxs-r3*(Vbetas-Vys)-2*Vo1s)/r3b2;
  Vcs=-(Valphas+Vxs+r3*(Vbetas-Vys)-2*Vo1s)/r3b2;
// active deadband compensation (c) Lotfi
	Vas+=sign(Ias)*Vdb;
	Vbs+=sign(Ibs)*Vdb;
	Vcs+=sign(Ics)*Vdb;
/*
if Hexa then
  begin
    Uxsn:= (Valphas-Vxs-r3*(Vbetas+Vys)+2*Vo2s)/r3b2;
    Uysn:= (Valphas-Vxs+r3*(Vbetas+Vys)+2*Vo2s)/r3b2;
    Uzsn:=-(Valphas-Vxs-Vo2s)/r3;
  end */
  dVas= (Vbetas+Vys+r3*(Valphas-Vxs)+2*Vo2s)/r3b2;
  dVbs= (Vbetas+Vys-r3*(Valphas-Vxs)+2*Vo2s)/r3b2;
  dVcs=-(Vbetas+Vys-Vo2s)/r3;
	dVas+=sign(dIas)*Vdb;
	dVbs+=sign(dIbs)*Vdb;
	dVcs+=sign(dIcs)*Vdb;

/*	ds1104_dac_write( 2, -1.0);	 signal out */
/* tempo 
	ds1104_dac_write( 1, Vsref/E_2*2-1);
   tempo : sort sur DAC 1 la valeur de VsRef /300 */

if (InhibEt12==1)	{ Vas=0; Vbs=0; Vcs=0; }				//arrte l'etoile 1 (onduleur1 : full PWM  50%)
if (InhibEt12==2)	{ dVas=0; dVbs=0; dVcs=0; }			//arrte l'etoile 2 (onduleur2 : simple PWM  50%)

// protection contre surcourant
	if (fabs(Ias)>IsmaxProtect || fabs(Ibs)>IsmaxProtect || fabs(dIas)>IsmaxProtect || fabs(dIbs)>IsmaxProtect)
				InhibFlag=1;

  /* write PWM Duty cycle to slave DSP and test for error */
	if  (InhibFlag)		{	// met les tensions  0 
										duty1=0.5;
										duty2=0.5;
										duty3=0.5;
										dduty1=0.5; // double toile
										dduty2=0.5;
										dduty3=0.5;
										}
					else			{
										duty1=Vas*BY_2E_2+0.5;
										duty2=Vbs*BY_2E_2+0.5;
										duty3=Vcs*BY_2E_2+0.5;
										// double toile
										dduty1=dVas*BY_2E_2+0.5;
										dduty2=dVbs*BY_2E_2+0.5;
										dduty3=dVcs*BY_2E_2+0.5;
										}
	  ds1104_slave_dsp_pwm3_duty_write(task_id, index, duty1, duty2, duty3);

	scmpr_duties[SLVDSP_USRFCT_SIMPLEPWMUPDATE_DUTY1_LOC]=(1-dduty1)*1000;
	scmpr_duties[SLVDSP_USRFCT_SIMPLEPWMUPDATE_DUTY2_LOC]=(1-dduty2)*1000;
	scmpr_duties[SLVDSP_USRFCT_SIMPLEPWMUPDATE_DUTY3_LOC]=(1-dduty3)*1000;
  ds1104_slave_dsp_usrfct_execute(task_id, SLVDSP_USRFCT_SIMPLEPWMUPDATE, 
																					 SLVDSP_USRFCT_SIMPLEPWMUPDATE_PCNT, scmpr_duties);

/*	ds1104_dac_write( 2, -0.5);	 signal out */
}


/*******************************************************************************/
/* l'autre routine qui s'excute qd la prcdente ne s'excute pas (tte les 200 us) */

void Regul_Vitesse_and_sensorlessFN()
{
	/* ds1104_dac_write( 3, 1);	*/
	if ( ++countSpeed!=DS_WReg )	return;
	countSpeed=0;									
		/* Interruption a 1 ms */
		/* La vitesse et la POSITION a partir d'une macro */
	inputWm;
	Wm=WmMesure;

	if ( PosControlFlag )
			if ( ++countPos==DS_PReg )	{
																	countPos=0;
																	BouclePosition();	/* regul posisition */
																	}

	/* ds1104_dac_write( 3, 0.5);		 signal 3 ! out */

		if ( SpeedControlFlag)
				{
				if (!TestIqs)				{
														if (!TestWm && !RampeWm)	TestWminc=0;
														if (RampeWm){
																				TestWminc++;
																				switch (RampePhase)
																					{
																					case 2	: Wmref=EchWmref*2*(TestWminc/(double)Testinclimph2-0.5);
																										if (TestWminc>=Testinclimph2){	TestWminc=0;
																																									RampePhase=1;
																																								}
																										break;
																					case 1	: Wmref=EchWmref;
																										if (TestWminc>=Testinclim)		{	TestWminc=0;
																																									RampePhase=-2;
																																								}
																										break;
																					case -2 : Wmref=-EchWmref*2*(TestWminc/(double)Testinclimph2-0.5);
																										if (TestWminc>=Testinclimph2){	TestWminc=0;
																																									RampePhase=-1;
																																								}
																										break;
																					case -1 : Wmref=-EchWmref;
																										if (TestWminc>=Testinclim)		{	TestWminc=0;
																																									RampePhase=2;
																																								}
																										break;
																					}
																				}

														if (TestWm)
																				{	// on va se faire des echelons de +/- EchWmref
																				TestWminc++;
																				if (TestWminc>Testinclim)		{
																																		TestWminc=0;
																																		if (Wmref==EchWmref)	Wmref=-EchWmref;
																																				else		Wmref=EchWmref;
																																		}
																				}

														switch ( SpeedControllerType )
																{
																case 1 :	BoucleVitesseFloue(); break;	/* Controlleur Flou */
																default :	BoucleVitesse();			/*classique */
																}
														TestIqsDeb=1;
														Testinc=0;
														}
						else		{	// on va se faire des echelons de +/- EchIqsref
										Testinc++;
										if (TestIqsDeb)	{
																		Iqsref=EchIqsref;
																		if (Testinc>Testinclim1)		{
																																TestIqsDeb=0;
																																Testinc=0;
																																Iqsref=-Iqsref;
																																}
																		}
											else		{
															if (Testinc>Testinclim2)		{
																													Testinc=0;
																													Iqsref=-Iqsref;
																													}
															}
										}
				}
	/* ds1104_dac_write( 3, 0.0);	 signal 3 ! out */
}
