/*
	Commande Vectorielle Indirecte par Orientation du Flux Rotorique
	------------  reconfiguration complte Pour DS1104  ------------

	reconfiguration complte Pour DS1104 et Double toile !!!
	SimplePWM synchronise avec FullPWM sur timer1
	Lotfi BAGHLI			  rev 23/11/2004
	light version Lotfi BAGHLI			  rev 12/12/2006

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "usrdsp.h"                     /* My user module definitions !!!*/
#include "Slv1104_fw240.slc"               /* firmware object code */
#include <brtenv.h>                           /* basic real-time environment */
#include <math.h>		/* sin cos */
#include "ctrl.h"		/* Declaration des fonctions + macros + includes 
												Declaration de variables + initialisation*/

/*---------------------------------------------------------------------------*/
/* interrupt service routine for PWM sync interrupt */

void PWM_sync_interrupt(void)
{
	ds1104_bit_io_set(DS1104_DIO0 | DS1104_DIO1);
	
  RTLIB_TIC_START();                              /* start time measurement */
	ds1104_bit_io_clear(DS1104_DIO0);

	switch(countCurrent)
		{
		case 0	:	RegulI_Control();
							break;
		case 1	:	Regul_Vitesse_and_sensorlessFN();
							host_service(1, 0);															/* Data Acquisition service */
							break;
		}
	if (++countCurrent==DS_IReg)	countCurrent=0;

	ds1104_bit_io_clear(DS1104_DIO1);

  exec_time = RTLIB_TIC_READ();
}

/*---------------------------------------------------------------------------*/
void main(void)
{
	UInt16 data;

  init();                             /* DS1104 and RTLib1104 initialization */
	initVar();
  ds1104_slave_dsp_appl_load((Int32 *) &fw240);
  
	msg_info_set(0, 0, "Systeme : double etoile synch, started.");

	/* init communication with slave_dsp */
  ds1104_slave_dsp_communication_init();

	/* inutile d'enregistrer mes fonctions :
		slvdsp_usrfct_simplePWMsynch
		slvdsp_usrfct_simplePWMupdate
		car ce sont des fonctions directes !*/

	/* init incremental encoder channel 1  : input signal for channel 1 via RS422 */
  ds1104_inc_init(1, DS1104_INC_MODE_RS422);
  ds1104_inc_set_idxmode(1, DS1104_INC_IDXMODE_OFF);

	/* config IO 0 et 1 output */
	ds1104_bit_io_init( DS1104_DIO0_OUT | DS1104_DIO1_OUT);
	ds1104_bit_io_clear(DS1104_DIO0 | DS1104_DIO1);

	/* config DAC */
	ds1104_dac_init( DS1104_DACMODE_TRANSPARENT);

  /* init of 3-phase PWM generation on slave DSP */
  ds1104_slave_dsp_pwm3_init(task_id, MLIperiod, duty1, duty2, duty3, deadband, sync_pos);
			// et de la double toile (slave simple PWM 7,8,9)
  ds1104_slave_dsp_pwm_init(task_id, MLIperiod, dduty1, SLVDSP1104_PWM_MODE_SYM, SLVDSP1104_PWM_POL_HIGH,
						SLVDSP1104_PWM_CH2_MSK | SLVDSP1104_PWM_CH3_MSK | SLVDSP1104_PWM_CH4_MSK);

	/* start of 3-phase PWM generation on slave DSP */
  ds1104_slave_dsp_pwm3_start(task_id);
			// et de la double toile (slave simple PWM 7,8,9) ie channel 2, 3, 4
  ds1104_slave_dsp_pwm_start(task_id, SLVDSP1104_PWM_CH2_MSK | SLVDSP1104_PWM_CH3_MSK | SLVDSP1104_PWM_CH4_MSK);

// on reconfigure la simple PWM sur timer1 ! (pas de paramtres)
  ds1104_slave_dsp_usrfct_execute(task_id, SLVDSP_USRFCT_SIMPLEPWMSYNCH, 0, &data);

  /* registration of PWM duty cycle update command */
  ds1104_slave_dsp_pwm3_duty_write_register(task_id, &index);
// et de la double toile (slave simple PWM 7,8,9) 
	// en virg.fixe via fonct usr
	scmpr_duties[SLVDSP_USRFCT_SIMPLEPWMUPDATE_DUTY1_LOC]=(1-dduty1)*1000;
	scmpr_duties[SLVDSP_USRFCT_SIMPLEPWMUPDATE_DUTY2_LOC]=(1-dduty2)*1000;
	scmpr_duties[SLVDSP_USRFCT_SIMPLEPWMUPDATE_DUTY3_LOC]=(1-dduty3)*1000;
	ds1104_slave_dsp_usrfct_execute(task_id, SLVDSP_USRFCT_SIMPLEPWMUPDATE, 
																					 SLVDSP_USRFCT_SIMPLEPWMUPDATE_PCNT, scmpr_duties);
//____________________________________________

	/* ADC Init and Sync */
   ds1104_adc_mux( 1); /* le 16 bit ADC sur channel 1) */
    /* 12 bits ADC 1 to 4 ie 2 to 5 are Courants Ias, Ibs et f.e.m. Ealphas et Ebetas */
   ds1104_adc_trigger_setup( 1, DS1104_TRIGGER_ENABLE); 
   ds1104_adc_trigger_setup( 2, DS1104_TRIGGER_ENABLE); 
   ds1104_adc_trigger_setup( 3, DS1104_TRIGGER_ENABLE); 
   ds1104_adc_trigger_setup( 4, DS1104_TRIGGER_ENABLE); 
   ds1104_adc_trigger_setup( 5, DS1104_TRIGGER_ENABLE); 
   ds1104_syncin_edge_setup( DS1104_SYNC_TRIGGER_RISING);

  /* initialization of PWM sync interrupt */
  ds1104_set_interrupt_vector(DS1104_INT_SLAVE_DSP_PWM,
                              (DS1104_Int_Handler_Type) &PWM_sync_interrupt, SAVE_REGS_ON);
  ds1104_enable_hardware_int(DS1104_INT_SLAVE_DSP_PWM);
  RTLIB_INT_ENABLE();
  /* Background tasks */
  while(1)
  {
    RTLIB_BACKGROUND_SERVICE();                        /* background service */
  }
}
	